/**************************************************************************/
/*									  */
/* Copyright (c) 2000 by Alexandr V.Shutko, Khabarovsk, Russia		  */
/* All rights reserved.							  */
/*                                                                        */
/* Redistribution and use in source and binary forms, with or without	  */
/* modification, are permitted provided that the following conditions	  */
/* are met:								  */
/* 1. Redistributions of source code must retain the above copyright	  */
/*    notice, this list of conditions and the following disclaimer.	  */
/* 2. Redistributions in binary form must reproduce the above copyright	  */
/*    notice, this list of conditions and the following disclaimer in 	  */
/*    the documentation and/or other materials provided with the 	  */
/*    distribution.							  */
/*                                                                        */
/* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  */
/* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 	  */
/* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS  */
/* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 	  */
/* OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT   */
/* OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 	  */
/* BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,  */
/* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE   */
/* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 	  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.			  */
/*									  */
/**************************************************************************/

#ifndef DB_PROTO_H
#define DB_PROTO_H

int db_online_lookup(unsigned long user_uin, struct online_user &temp_user);
int db_online_lookup(unsigned long to_uin, struct online_user &temp_user, unsigned short magnum1, unsigned short magnum2);
int db_online_sseq_open(struct online_user &temp_user);
int db_online_sseq_close(struct online_user &temp_user, int);
int db_online_delete(unsigned long uin);
int db_online_insert(struct online_user &temp_user);
int db_online_touch(struct online_user &temp_user);
int db_online_update_servseq(struct online_user &temp_user);
int db_online_add_servseq(unsigned long uin, int number);
int db_online_setstatus(struct online_user &temp_user);
int db_online_setstate(struct online_user &temp_user, int state);
void oNoticeStub(void * arg, const char * message);
void uNoticeStub(void * arg, const char * message);

int db_contact_insert(unsigned long uin, int number, unsigned long *contact, int type);
int db_contact_delete(unsigned long uin);
int db_contact_lookup(unsigned long uin, int type, unsigned long *contact[]);

int db_users_lookup(unsigned long to_uin, struct full_user_info &temp_user);
int db_users_lookup(unsigned long to_uin, struct login_user_info &temp_user);
int db_users_touch(struct online_user &user);
int db_users_notes(unsigned long to_uin, struct notes_user_info &notes);
int db_users_lock_message(unsigned long to_uin, fstring &lock_text);
int db_users_setnotes(unsigned long to_uin, struct notes_user_info &notes);
int db_users_setbasic_info(unsigned long to_uin, struct full_user_info &userinfo);
int db_users_setwebpage_info(unsigned long to_uin, char *user_page, int htype);
int db_users_sethome_info(unsigned long to_uin, struct full_user_info &userinfo);
int db_users_setwork_info(unsigned long to_uin, struct full_user_info &userinfo);
int db_users_setpassword(unsigned long to_uin, char *new_password);
int db_users_setauthmode(unsigned long to_uin, int auth);
int db_users_clear_ch_pass(unsigned long to_uin);
int db_users_add_user(struct full_user_info &user);
int db_new_add_user(struct full_user_info &user);

unsigned long db_users_new_uin();
unsigned long db_users_new_uin2();

int db_add_message(unsigned long from_uin, unsigned long to_uin, int type, char *message);
int db_del_messages(unsigned long to_uin, unsigned long last_time);

int db_defrag_addpart(unsigned long from_uin, int seq, int part_num, int part_cnt, int len, char *buffer);
int db_defrag_delete(unsigned long from_uin);
int db_defrag_delete(unsigned long from_uin, unsigned long seq);
int db_defrag_check(unsigned long from_uin, unsigned long seq);

void usersdb_connect();

BOOL new_users_table_exist();
void create_new_users_table();

/* init_db.cpp protos */
BOOL check_and_fix_database(char *dbname, char *dbuser, char *dbpass, char *dbaddr, char *dbport);
BOOL check_user_tbl(PGconn *dbconn, char *tbl_name, int fldnum);
BOOL create_user_tbl(PGconn *dbconn, char *cr_query);
BOOL grant_permissions(PGconn *dbconn, char *tbl_name, char *username);
BOOL delete_user_tbl(PGconn *dbconn, char *tblname);

#endif /* DB_PROTO_H */
