/**************************************************************************/
/*									  */
/* Copyright (c) 2000 by Alexandr V.Shutko, Khabarovsk, Russia		  */
/* All rights reserved.							  */
/*                                                                        */
/* Redistribution and use in source and binary forms, with or without	  */
/* modification, are permitted provided that the following conditions	  */
/* are met:								  */
/* 1. Redistributions of source code must retain the above copyright	  */
/*    notice, this list of conditions and the following disclaimer.	  */
/* 2. Redistributions in binary form must reproduce the above copyright	  */
/*    notice, this list of conditions and the following disclaimer in 	  */
/*    the documentation and/or other materials provided with the 	  */
/*    distribution.							  */
/*                                                                        */
/* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  */
/* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 	  */
/* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS  */
/* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 	  */
/* OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT   */
/* OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 	  */
/* BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,  */
/* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE   */
/* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 	  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.			  */
/*									  */
/* This unit implements users info database calls (lookup, change, add,   */
/* delete, auth, etc) for packet processors				  */
/*									  */
/* Contributor:	Alexandr V. Shutko <AVShutko@mail.khstu.ru>		  */
/* Created:	01 September 2000					  */
/* Updated:	26 December 2000 by Regressor <AVShutko@mail.khstu.ru>	  */
/*									  */
/**************************************************************************/

#include "includes.h"

/**************************************************************************/
/* This function add user record to database			   	  */
/**************************************************************************/
int db_new_add_user(struct full_user_info &user)
{
  PGresult *res;  

  typedef char ins_string[10000];
  ins_string insert_str;
   
  /* now prepare sql command string */
  snprintf(insert_str, 10000, "INSERT INTO register_requests VALUES 
       ('%lu', '%s', '%d', '%lu', '%lu', '%d', '%lu', '%d', '%s', '%s', 
        '%s', '%s', '%s', '%s', '%d', '%d', '%d', '%d', '%d', '%d', 
	'%d', '%d', '%s', '%s', '%s', '%d', '%s', '%s', '%d', '%lu', 
	'%s', '%s', '%s', '%lu', '%s', '%s', '%s', '%s', '%s', '%d', 
	'%s', '%s', '%s', '%lu', '%s', '%lu')", 

        user.uin, user.passwd, user.disabled, user.lastlogin, user.ip_addr, 
	user.can_broadcast, user.cr_date, user.ch_password, user.nick, 
	user.first, user.last, user.email1, user.email2, user.email3,
	user.pemail1, user.gmt_offset, user.auth, user.gender, user.age,
	user.bday, user.bmonth, user.byear, user.waddr, user.wcity, 
	user.wstate, user.wcountry, user.wcompany, user.wtitle, user.wocup, 
	user.wdepart, user.wphone, user.wfax, user.wpager, user.wzip, 
	user.wpage, user.notes, user.haddr, user.hcity, user.hstate, 
	user.hcountry, user.hphone, user.hfax, user.hcell, user.hzip,
	user.hpage, user.nupdate); 

      res = PQexec(users_dbconn, insert_str);
      if (PQresultStatus(res) != PGRES_COMMAND_OK)
      {
      
         LOG_SYS(10, ("SQL command failed... :(\n"));
         PQclear(res);
	 exit(-2);
      }
      else
      {
         PQclear(res);
      }
      
      return(0);
}

/**************************************************************************/
/* This function add user record to database			   	  */
/**************************************************************************/
int db_users_add_user(struct full_user_info &user)
{
  PGresult *res;  

  typedef char ins_string[10000];
  ins_string insert_str;
   
  /* now prepare sql command string */
  snprintf(insert_str, 10000, "INSERT INTO Users_info VALUES 
       ('%lu', '%s', '%d', '%lu', '%lu', '%d', '%lu', '%d', '%s', '%s', 
        '%s', '%s', '%s', '%s', '%d', '%d', '%d', '%d', '%d', '%d', 
	'%d', '%d', '%s', '%s', '%s', '%d', '%s', '%s', '%d', '%lu', 
	'%s', '%s', '%s', '%lu', '%s', '%s', '%s', '%s', '%s', '%d', 
	'%s', '%s', '%s', '%lu', '%s', '%lu')", 

        user.uin, user.passwd, user.disabled, user.lastlogin, user.ip_addr, 
	user.can_broadcast, user.cr_date, user.ch_password, user.nick, 
	user.first, user.last, user.email1, user.email2, user.email3,
	user.pemail1, user.gmt_offset, user.auth, user.gender, user.age,
	user.bday, user.bmonth, user.byear, user.waddr, user.wcity, 
	user.wstate, user.wcountry, user.wcompany, user.wtitle, user.wocup, 
	user.wdepart, user.wphone, user.wfax, user.wpager, user.wzip, 
	user.wpage, user.notes, user.haddr, user.hcity, user.hstate, 
	user.hcountry, user.hphone, user.hfax, user.hcell, user.hzip,
	user.hpage, user.nupdate); 

      res = PQexec(users_dbconn, insert_str);
      if (PQresultStatus(res) != PGRES_COMMAND_OK)
      {
      
         LOG_SYS(10, ("SQL command failed... :(\n"));
         PQclear(res);
	 exit(-2);
      }
      else
      {
         PQclear(res);
      }

      return(0);
}

/**************************************************************************/
/* This function used to create new register requests table     	  */
/**************************************************************************/
void create_new_users_table()
{
   PGresult *res;
   cstring dbcomm_str;

   /* exec select command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "CREATE TABLE register_requests () INHERITS (users_info);");

   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_COMMAND_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));

      PQclear(res);
      return;
   }
   
   PQclear(res);
}


/**************************************************************************/
/* This function used generte new uin number 				  */
/**************************************************************************/
BOOL new_users_table_exist()
{
   PGresult *res;
   cstring dbcomm_str;

   /* exec select command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "select count(*) FROM pg_tables WHERE 
	    tablename = 'register_requests'");

   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_TUPLES_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(False);
   }

   if (PQnfields(res) != 1) 
   {
      LOG_SYS(0, ("Corrypted table structure in db: \"%s\"\n", 
                  lp_db_users()));
      exit(-1);
   }
   
   if (PQntuples(res) > 0) return (atol(PQgetvalue(res, 0, 0)));
   
   return (False);
}

/**************************************************************************/
/* This function used generte new uin number 				  */
/**************************************************************************/
unsigned long db_users_new_uin()
{
   PGresult *res;
   cstring dbcomm_str;
   unsigned long result_uin;
   char **valid = NULL;

   /* exec select command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "SELECT max(uin)+1 FROM users_info");

   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_TUPLES_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(0);
   }

   if (PQnfields(res) != 1) 
   {
      LOG_SYS(0, ("Corrypted table structure in db: \"%s\"\n", 
                  lp_db_users()));
      exit(-1);
   }
   
   if (PQntuples(res) > 0) 
   {
      result_uin = strtoul(PQgetvalue(res, 0, 0), valid, 10);
      if (result_uin < 1001) result_uin += 1001; 
      
      PQclear(res);
      return(result_uin);
   }
   else 
   {
      PQclear(res);
      return(0);
   }
}


/**************************************************************************/
/* This function used to generate new uin number 			  */
/**************************************************************************/
unsigned long db_users_new_uin2()
{
   PGresult *res;
   cstring dbcomm_str;
   unsigned long result_uin;
   char **valid = NULL;

   /* exec select command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "SELECT max(uin)+1 FROM register_requests");

   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_TUPLES_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(0);
   }

   if (PQnfields(res) != 1) 
   {
      LOG_SYS(0, ("Corrypted table structure in db: \"%s\"\n", 
                  lp_db_users()));
      exit(-1);
   }
   
   if (PQntuples(res) > 0) 
   {
      result_uin = strtoul(PQgetvalue(res, 0, 0), valid, 10);
      
      PQclear(res);
      return(result_uin);
   }
   else 
   {
      PQclear(res);
      return(0);
   }
}


/**************************************************************************/
/* This function used to clear change_password flag in userinfo		  */
/**************************************************************************/
int db_users_clear_ch_pass(unsigned long to_uin)
{
   PGresult *res;
   cstring dbcomm_str;
   
   /* exec update command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "UPDATE Users_Info SET cpass=0 WHERE uin=%lu", to_uin);
	    
   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_COMMAND_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(-1);
   }

   if (PQcmdTuples(res) != "")
   {
      PQclear(res);  
      return(0);
   }
   else 
   {
      PQclear(res);
      return(-1);    
   } 
}

/**************************************************************************/
/* This function used to change user's authorization mode		  */
/**************************************************************************/
int db_users_setauthmode(unsigned long to_uin, int auth)
{
   PGresult *res;
   cstring dbcomm_str;
   
   /* exec update command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "UPDATE Users_Info SET auth=%d WHERE uin=%lu", 
	    auth, to_uin);
	    
   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_COMMAND_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(-1);
   }

   if (PQcmdTuples(res) != "")
   {
      PQclear(res);  
      return(0);
   }
   else 
   {
      PQclear(res);
      return(-1);    
   } 
}

/**************************************************************************/
/* This function used to change user's password				  */
/**************************************************************************/
int db_users_setpassword(unsigned long to_uin, char *new_password)
{
   PGresult *res;
   cstring dbcomm_str;
   fstring npassword;
   
   /* now we should convert string to specified locale and PG format */   
   convert_to_postgres(npassword, sizeof(fstring)-1, new_password);

   /* exec update command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "UPDATE Users_Info SET pass='%s' WHERE uin=%lu", 
	    npassword, to_uin);
	    
   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_COMMAND_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(-1);
   }

   if (PQcmdTuples(res) != "")
   {
      PQclear(res);  
      db_users_clear_ch_pass(to_uin);
      
      return(0);
   }
   else 
   {
      PQclear(res);
      return(-1);    
   } 
}


/**************************************************************************/
/* This function used to set user's work info				  */
/**************************************************************************/
int db_users_setwork_info(unsigned long to_uin, struct full_user_info &userinfo)
{
   PGresult *res;
   cstring dbcomm_str;
   fstring waddr, wcity, wphone, wfax, wpager, wstate, wtitle, wcompany;
   
   /* now we should convert string to specified locale and PG format */   
   convert_to_postgres(waddr,    sizeof(fstring)-1, userinfo.waddr);
   convert_to_postgres(wcity,    sizeof(fstring)-1, userinfo.wcity);
   convert_to_postgres(wstate,   sizeof(fstring)-1, userinfo.wstate);
   convert_to_postgres(wphone,   sizeof(fstring)-1, userinfo.wphone);
   convert_to_postgres(wfax,     sizeof(fstring)-1, userinfo.wfax);
   convert_to_postgres(wpager,   sizeof(fstring)-1, userinfo.wpager);
   convert_to_postgres(wtitle,   sizeof(fstring)-1, userinfo.wtitle);   
   convert_to_postgres(wcompany, sizeof(fstring)-1, userinfo.wcompany);

   /* exec update command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "UPDATE Users_Info SET waddr='%s', wcity='%s', wstate='%s', 
	    wcountry=%d, wphon='%s', wfax='%s', wpager='%s', wzip='%d',
	    wdepart='%d', wtitle='%s', wcompany='%s' WHERE uin=%lu", 
	    waddr, wcity, wstate, userinfo.wcountry, wphone, wfax, wpager, 
	    userinfo.wzip, userinfo.wdepart, wtitle, wcompany, to_uin);
	    
   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_COMMAND_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(-1);
   }

   if (PQcmdTuples(res) != "")
   {
      PQclear(res);  
      return(0);
   }
   else 
   {
      PQclear(res);
      return(-1);    
   } 
}


/**************************************************************************/
/* This function used to set user's home info				  */
/**************************************************************************/
int db_users_sethome_info(unsigned long to_uin, struct full_user_info &userinfo)
{
   PGresult *res;
   cstring dbcomm_str;
   fstring haddr, hcity, hphone, hfax, hcell, hstate;
   
   /* now we should convert string to specified locale and PG format */   
   convert_to_postgres(haddr,  sizeof(fstring)-1, userinfo.haddr);
   convert_to_postgres(hcity,  sizeof(fstring)-1, userinfo.hcity);
   convert_to_postgres(hstate, sizeof(fstring)-1, userinfo.hstate);
   convert_to_postgres(hphone, sizeof(fstring)-1, userinfo.hphone);
   convert_to_postgres(hfax,   sizeof(fstring)-1, userinfo.hfax);
   convert_to_postgres(hcell,  sizeof(fstring)-1, userinfo.hcell);
   
   /* exec update command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "UPDATE Users_Info SET haddr='%s', hcity='%s', hstate='%s', 
	    hcountry=%d, hphon='%s', hfax='%s', hcell='%s', hzip='%d', 
	    sex=%d, bday=%d, bmon=%d, byear=%d, age=%d WHERE uin=%lu", 
	    haddr, hcity, hstate, userinfo.hcountry, hphone, hfax, 
	    hcell, userinfo.hzip, userinfo.gender, userinfo.bday, 
	    userinfo.bmonth, userinfo.byear, userinfo.age, to_uin);
	    
   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_COMMAND_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(-1);
   }

   if (PQcmdTuples(res) != "")
   {
      PQclear(res);  
      return(0);
   }
   else 
   {
      PQclear(res);
      return(-1);    
   } 
}


/**************************************************************************/
/* This function used to set user's home webpage address 		  */
/**************************************************************************/
int db_users_setwebpage_info(unsigned long to_uin, char *user_page, int htype)
{
   PGresult *res;
   cstring dbcomm_str;
   fstring webpage;
   
   /* now we should convert string to specified locale and PG format */   
   convert_to_postgres(webpage, sizeof(fstring)-1, user_page);
   
   /* exec update command on backend server */
   
   if (htype == HOME) { 
       slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
       "UPDATE Users_Info SET hweb='%s' WHERE uin=%lu", webpage, to_uin); 
   }
   
   if (htype == WORK) { 
       slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
       "UPDATE Users_Info SET wweb='%s' WHERE uin=%lu", webpage, to_uin); 
   }
   
   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_COMMAND_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(-1);
   }

   if (PQcmdTuples(res) != "")
   {
      PQclear(res);  
      return(0);
   }
   else 
   {
      PQclear(res);
      return(-1);    
   } 
}

/**************************************************************************/
/* This function used to set user's basic info				  */
/**************************************************************************/
int db_users_setbasic_info(unsigned long to_uin, struct full_user_info &userinfo)
{
   PGresult *res;
   cstring dbcomm_str;
   fstring nick, first, last, email;
   
   /* now we should convert string to specified locale and PG format */   
   convert_to_postgres(nick,  sizeof(fstring)-1, userinfo.nick);
   convert_to_postgres(first, sizeof(fstring)-1, userinfo.first);
   convert_to_postgres(last,  sizeof(fstring)-1, userinfo.last);
   convert_to_postgres(email, sizeof(fstring)-1, userinfo.email2);
   
   /* exec update command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "UPDATE Users_Info SET nick='%s', frst='%s', last='%s', email1='%s', 
	    email2='%s' WHERE uin=%lu", nick, first, last, 
	    email, email, to_uin);
	    
   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_COMMAND_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(-1);
   }

   if (PQcmdTuples(res) != "")
   {
      PQclear(res);  
      return(0);
   }
   else 
   {
      PQclear(res);
      return(-1);    
   } 
}

/**************************************************************************/
/* This function used to set new user's notes				  */
/**************************************************************************/
int db_users_setnotes(unsigned long to_uin, struct notes_user_info &notes)
{
   PGresult *res;
   cstring dbcomm_str, lnotes;

   /* now we should convert string to specified locale and PG format */   
   convert_to_postgres(lnotes, sizeof(lnotes)-1, notes.notes);

   /* exec select command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "UPDATE Users_Info SET notes='%s',nnotes=%lu WHERE uin=%lu", 
	    lnotes, time(NULL), to_uin);
	    
   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_COMMAND_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(-1);
   }

   if (PQcmdTuples(res) != "")
   {
      PQclear(res);  
      return(0);
   }
   else 
   {
      PQclear(res);
      return(-1);    
   }

}

/**************************************************************************/
/* This function used to obtain user's notes				  */
/**************************************************************************/
int db_users_notes(unsigned long to_uin, struct notes_user_info &notes)
{
   PGresult *res;
   fstring dbcomm_str;
   char **valid;

   /* exec select command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "SELECT notes,nnotes,llog,iadr FROM Users_info 
	   WHERE uin=%lu", to_uin);

   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_TUPLES_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(-1);
   }

   if (PQnfields(res) != 4) 
   {
      LOG_SYS(0, ("Corrypted table structure in db: \"%s\"\n", 
                  lp_db_users()));
      exit(-1);
   }
   
   if (PQntuples(res) > 0) 
   {
      valid = NULL; 
      strncpy(notes.notes, PQgetvalue(res, 0, 0), sizeof(notes.notes)-1);
      notes.uin	      = to_uin;
      notes.nupdate   = strtoul(PQgetvalue(res, 0, 1), valid, 10); 
                        valid = NULL;
      notes.lastlogin = strtoul(PQgetvalue(res, 0, 2), valid, 10); 
                        valid = NULL;
      notes.ip_addr   = strtoul(PQgetvalue(res, 0, 3), valid, 10);
      
      ITrans.translateToClient(notes.notes);
      PQclear(res);
      return(0);
   }
   else 
   {
      PQclear(res);
      return(-1);    
   }

}

/**************************************************************************/
/* This function used in login func to return full user info    	  */
/**************************************************************************/
int db_users_lookup(unsigned long to_uin, struct full_user_info &temp_user)
{
   PGresult *res;
   fstring dbcomm_str;

   /* exec select command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "SELECT * FROM Users_info WHERE uin=%lu", to_uin);

   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_TUPLES_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(-2);
   }

   if (PQnfields(res) != USERS_DB_FNUM) 
   {
      LOG_SYS(0, ("Corrypted table structure in db: \"%s\"\n", 
                  lp_db_users()));
      exit(-1);
   }
   
   if (PQntuples(res) > 0)
   {
      char **valid = NULL;
      
      /* basic info */
      temp_user.uin		= atol(PQgetvalue(res, 0,  0));
      temp_user.pemail1		= atol(PQgetvalue(res, 0, 14));
      temp_user.disabled	= atol(PQgetvalue(res, 0,  2));
      temp_user.can_broadcast	= atol(PQgetvalue(res, 0,  5));
      temp_user.ch_password	= atol(PQgetvalue(res, 0,  7));
      temp_user.auth		= atol(PQgetvalue(res, 0, 16));
      temp_user.age		= atol(PQgetvalue(res, 0, 18));
      temp_user.gender		= atol(PQgetvalue(res, 0, 17));
      temp_user.gmt_offset      = atol(PQgetvalue(res, 0, 15));
      
      temp_user.bmonth		= atol(PQgetvalue(res, 0, 20));
      temp_user.bday		= atol(PQgetvalue(res, 0, 19));
      temp_user.byear		= atol(PQgetvalue(res, 0, 21));
      temp_user.wocup		= atol(PQgetvalue(res, 0, 28));

      temp_user.wzip 		= atol(PQgetvalue(res, 0, 33));
      if (temp_user.wzip == 0)  temp_user.wcountry = -1;
      temp_user.hzip 		= atol(PQgetvalue(res, 0, 43));
      if (temp_user.hzip == 0)  temp_user.wcountry = -1;
      temp_user.wdepart		= atol(PQgetvalue(res, 0, 29));
      if (temp_user.wdepart == 0) temp_user.wdepart = -1;
            
      temp_user.wcountry	= atol(PQgetvalue(res, 0, 25));
      if (temp_user.wcountry == 0) temp_user.wcountry = -1;
      temp_user.hcountry	= atol(PQgetvalue(res, 0, 39));
      if (temp_user.hcountry == 0) temp_user.hcountry = -1;
      
      temp_user.cr_date		= strtoul(PQgetvalue(res, 0,  6), 
                                  valid, 10); valid = NULL;
      temp_user.lastlogin	= strtoul(PQgetvalue(res, 0,  3),
                                  valid, 10); valid = NULL;
      temp_user.ip_addr		= strtoul(PQgetvalue(res, 0,  4),
                                  valid, 10); valid = NULL;
      temp_user.nupdate		= strtoul(PQgetvalue(res, 0, 45),
                                  valid, 10); valid = NULL;

      snprintf(temp_user.passwd, 32, PQgetvalue(res, 0,  1));
      ITrans.translateToClient(temp_user.passwd);
      snprintf(temp_user.nick  , 32, PQgetvalue(res, 0,  8));
      ITrans.translateToClient(temp_user.nick);
      snprintf(temp_user.last  , 32, PQgetvalue(res, 0, 10));
      ITrans.translateToClient(temp_user.last);
      snprintf(temp_user.first , 32, PQgetvalue(res, 0,  9));
      ITrans.translateToClient(temp_user.first);
      snprintf(temp_user.email1, 64, PQgetvalue(res, 0, 11));
      ITrans.translateToClient(temp_user.email1);
      snprintf(temp_user.email2, 64, PQgetvalue(res, 0, 12));
      ITrans.translateToClient(temp_user.email2);
      snprintf(temp_user.email3, 64, PQgetvalue(res, 0, 13));
      ITrans.translateToClient(temp_user.email3);
      
      snprintf(temp_user.notes , 255, PQgetvalue(res, 0, 45));
      ITrans.translateToClient(temp_user.notes);
      
      /* home info */
      snprintf(temp_user.haddr , 64, PQgetvalue(res, 0, 36));
      ITrans.translateToClient(temp_user.haddr);
      snprintf(temp_user.hcity , 32, PQgetvalue(res, 0, 37));
      ITrans.translateToClient(temp_user.hcity);
      snprintf(temp_user.hstate, 32, PQgetvalue(res, 0, 38));
      ITrans.translateToClient(temp_user.hstate);
      snprintf(temp_user.hphone, 32, PQgetvalue(res, 0, 40));
      ITrans.translateToClient(temp_user.hphone);
      snprintf(temp_user.hfax  , 32, PQgetvalue(res, 0, 41));
      ITrans.translateToClient(temp_user.hfax);
      snprintf(temp_user.hcell , 32, PQgetvalue(res, 0, 42));
      ITrans.translateToClient(temp_user.hcell);
      snprintf(temp_user.hpage ,128, PQgetvalue(res, 0, 44));
      ITrans.translateToClient(temp_user.hpage);
      
      /* work info */
      snprintf(temp_user.waddr , 64, PQgetvalue(res, 0, 22));
      ITrans.translateToClient(temp_user.waddr);
      snprintf(temp_user.wcity , 32, PQgetvalue(res, 0, 23));
      ITrans.translateToClient(temp_user.wcity);
      snprintf(temp_user.wstate, 32, PQgetvalue(res, 0, 24));
      ITrans.translateToClient(temp_user.wstate);
      snprintf(temp_user.wcompany, 32, PQgetvalue(res, 0, 26));
      ITrans.translateToClient(temp_user.wcompany);
      snprintf(temp_user.wtitle, 32, PQgetvalue(res, 0, 27));
      ITrans.translateToClient(temp_user.wtitle);
      snprintf(temp_user.wphone, 32, PQgetvalue(res, 0, 30));
      ITrans.translateToClient(temp_user.wphone);
      snprintf(temp_user.wfax  , 32, PQgetvalue(res, 0, 31));
      ITrans.translateToClient(temp_user.wfax);
      snprintf(temp_user.wpager, 32, PQgetvalue(res, 0, 32));
      ITrans.translateToClient(temp_user.wpager);
      snprintf(temp_user.wpage ,128, PQgetvalue(res, 0, 34));
      ITrans.translateToClient(temp_user.wpage);

      PQclear(res);  
      return(0);
   }
   else 
   {
      PQclear(res);
      return(-1);    
   }

}

/**************************************************************************/
/* This function used in login func to return partial user info 	  */
/**************************************************************************/
int db_users_lookup(unsigned long to_uin, struct login_user_info &temp_user)
{
   PGresult *res;
   fstring dbcomm_str;

   /* exec select command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "SELECT uin,pass,e1publ,ulock,bcst,cpass FROM 
	    Users_info WHERE uin=%lu", to_uin);

   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_TUPLES_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(-2);
   }

   if (PQnfields(res) != 6) 
   {
      LOG_SYS(0, ("Corrypted table structure in db: \"%s\"\n", 
                  lp_db_users()));
      exit(-1);
   }
   
   if (PQntuples(res) > 0)
   {
      temp_user.uin		= atol(PQgetvalue(res, 0, 0));
      temp_user.pemail1		= atol(PQgetvalue(res, 0, 2));
      temp_user.disabled	= atol(PQgetvalue(res, 0, 3));
      temp_user.can_broadcast	= atol(PQgetvalue(res, 0, 4));
      temp_user.ch_password	= atol(PQgetvalue(res, 0, 5));
      
      strncpy(temp_user.passwd, PQgetvalue(res, 0, 1), 32);
      ITrans.translateToClient(temp_user.passwd);
    
      PQclear(res);  
      return(0);
   }
   else 
   {
      PQclear(res);
      return(-1);    
   }
}

/**************************************************************************/
/* This function used to update user information (ip, lastlogin)	  */
/**************************************************************************/
int db_users_touch(struct online_user &user)
{
   PGresult *res;
   fstring dbcomm_str;

   /* exec select command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "UPDATE Users_info SET llog=%lu,iadr=%lu WHERE uin=%lu", 
	    timeToLong(time(NULL)), ipToIcq(user.ip), user.uin);

   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_COMMAND_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(-1);
   }
    
  PQclear(res);  
  return(0);
}

/**************************************************************************/
/* If user's account locked this function used to obtain 		  */
/* iserver administrator lock message 					  */
/**************************************************************************/
int db_users_lock_message(unsigned long to_uin, fstring &lock_text)
{
   PGresult *res;
   fstring dbcomm_str;

   /* exec select command on backend server */
   slprintf(dbcomm_str, sizeof(dbcomm_str)-1, 
           "SELECT lck_text FROM Users_lock WHERE luin=%lu", to_uin);

   res = PQexec(users_dbconn, dbcomm_str);
   if (PQresultStatus(res) != PGRES_TUPLES_OK)
   {
      LOG_SYS(0, ("SQL Command failed...\n"));
      LOG_SYS(0, ("%s", PQresultErrorMessage(res)));
      PQclear(res);
      return(0);
   }

   if (PQnfields(res) != 1) 
   {
      LOG_SYS(0, ("Corrypted table structure in db: \"%s\"\n", 
                  lp_db_users()));
      exit(-1);
   }
   
   if (PQntuples(res) > 0)
   {
      snprintf(lock_text, sizeof(lock_text)-1, PQgetvalue(res, 0, 0));
      PQclear(res);
      return(1);
   }
   else 
   {
      PQclear(res);
      return(0);    
   }

}

/**************************************************************************/
/* This function make connection to users database		 	  */
/**************************************************************************/
void usersdb_connect()
{
   char	    *pghost, *pgport,  *pgoptions, *pgtty;
   char	    *dbName, *dblogin, *dbpassw;	    

   pghost  = lp_db_addr();	/* address of db server if NULL - unix */
   pgport  = lp_db_port();	/* port of the backend */
   dbName  = lp_db_users();	/* online database name */
   dblogin = lp_db_user();	/* database user */
   dbpassw = lp_db_pass();	/* database password */
   
   pgoptions = NULL;		/* special options for backend server */
   pgtty     = NULL;		/* debugging tty for the backend server */


				/* make a connection to the database */
   users_dbconn = PQsetdbLogin(pghost, pgport, pgoptions, pgtty, 
                                dbName, dblogin, dbpassw);

   if (PQstatus(users_dbconn) == CONNECTION_BAD)
	{
   	   LOG_SYS(0, ("Connection to users database failed.\n"));
	   LOG_SYS(0, ("%s", PQerrorMessage(users_dbconn)));
	   exit(-1);
	}
	
   PQsetNoticeProcessor(users_dbconn, 
   (void (*)(void *, const char *))uNoticeStub, NULL);
}


/**************************************************************************/
/* I DON'T WANT RECEIVE SPAM SHIT NOTICE MESSAGES FROM BACKEND!!!!!   	  */
/* I lost whole day trying understand why libpq send spam to server   	  */
/* incoming IPC pipe and then found that pipe after closing stderr    	  */
/* receive the SAME number and foolish libpq notice processor         	  */
/* simply make printf(stderr, bla-bla-bla) to server pipe!!!		  */
/**************************************************************************/
void uNoticeStub(void * arg, const char * message)
{
   char stripped[32];
   strncpy(stripped, message, 31);
   string_truncate(stripped, 28);
   
   /* if this ocuppied - we should abort current transaction */
   if (strequal(stripped, "NOTICE:  current transaction"))
   {
      LOG_ALARM(10, ("Problem: Transaction aborted... Reconnecting...\n"));
      PQfinish(users_dbconn);
      exit(0);
   }
      
   return;
}
