/**************************************************************************/
/*									  */
/* Copyright (c) 2000 by Alexandr V.Shutko, Khabarovsk, Russia		  */
/* All rights reserved.							  */
/*                                                                        */
/* Redistribution and use in source and binary forms, with or without	  */
/* modification, are permitted provided that the following conditions	  */
/* are met:								  */
/* 1. Redistributions of source code must retain the above copyright	  */
/*    notice, this list of conditions and the following disclaimer.	  */
/* 2. Redistributions in binary form must reproduce the above copyright	  */
/*    notice, this list of conditions and the following disclaimer in 	  */
/*    the documentation and/or other materials provided with the 	  */
/*    distribution.							  */
/*                                                                        */
/* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  */
/* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 	  */
/* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS  */
/* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 	  */
/* OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT   */
/* OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 	  */
/* BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,  */
/* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE   */
/* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 	  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.			  */
/*									  */
/* This file contain definitions for packet confirm-queue structures 	  */
/*									  */
/* Contributor:	Alexandr V. Shutko <AVShutko@mail.khstu.ru>		  */
/* Created:	03 November 2000					  */
/* Updated:	26 December 2000 by Regressor <AVShutko@mail.khstu.ru>	  */
/*									  */
/**************************************************************************/

#ifndef _CONFIRM_H_
#define _CONFIRM_H_

/* We need special structure to keep unconfirmed packet in queue */

typedef struct indirect_pack
{
   unsigned int sizeVal;	// data size (packet size)

   unsigned int to_port;	// destination port
   in_addr to_ip;		// destination address
   
   unsigned int retry_num;	// number of retries
   unsigned int ctime_out;	// current timeout
   unsigned int time_out;	// max time to next retry
  
   unsigned long ask_stamp;	// uinique packet stamp
   unsigned long to_uin;	// to whom we send pack
   char buff[MAX_PACKET_SIZE];	// data buffer (packet)

} indirect_pack;

/* Single record in unsent packets list */

typedef struct indpack_record
{
    struct indpack_record *prev;    // previous record pointer
    struct indpack_record *next;    // next record pointer
    struct indirect_pack  ipacket;  // ind packet structure 

} indpack_record;

#define MESS_ACK 100
#define MESS_ONLINE  101
#define MESS_OFFLINE 102
#define MESS_UPDATE  103
#define MESS_TIMEOUT 104

/* event message structure (for delivering ask signals) */

typedef struct event_pack
 {
   unsigned long  mtype;	    /* event type (DB_CHANGE or ACK_PACK) */
   unsigned long  uin_number;	    /* uin of event person */
   unsigned long  ack_stamp;	    /* unique number for ack packets */
   unsigned short ttl;
 
} event_pack;

#endif
