/**************************************************************************/
/*									  */
/* Copyright (c) 2000 by Alexandr V.Shutko, Khabarovsk, Russia		  */
/* All rights reserved.							  */
/*                                                                        */
/* Redistribution and use in source and binary forms, with or without	  */
/* modification, are permitted provided that the following conditions	  */
/* are met:								  */
/* 1. Redistributions of source code must retain the above copyright	  */
/*    notice, this list of conditions and the following disclaimer.	  */
/* 2. Redistributions in binary form must reproduce the above copyright	  */
/*    notice, this list of conditions and the following disclaimer in 	  */
/*    the documentation and/or other materials provided with the 	  */
/*    distribution.							  */
/*                                                                        */
/* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  */
/* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 	  */
/* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS  */
/* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 	  */
/* OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT   */
/* OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 	  */
/* BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,  */
/* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE   */
/* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 	  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.			  */
/*									  */
/**************************************************************************/

#include "icontrol.h"

extern struct TServinfo sinfo;


/* broadcast message structure for bcast dialog fields */
struct bcast_msg
{
    unsigned short online_only;
    char department[20];
    char subject[128];
    char message[1024];
    char button[128];
    char URL[128];
};

/* broadcast message packet to install in dialog */
bcast_msg bcast_message;

/**************************************************************************/
/* dialog routine to send admin broadcast messages 			  */
/**************************************************************************/
void TMyApp::admin_bcast()
{
    int Control;
    char bc_full_message[2048];
    
    TDialog *pd = new TDialog( TRect( 20, 2, 64, 21), "Broadcast message" );
    
    if( pd )
    {
	class TView *b, *b1;

        b = new TCheckBoxes( TRect( 2, 2, 25, 3),
            new TSItem( "To ~o~nline only", 0 ));
        pd->insert( b );

	pd->insert( new TInputLine( TRect( 2, 4, 25, 5), 20));
	
	b = new TInputLine( TRect( 11, 6, 42, 7), 128); pd->insert( b );
	pd->insert( new TLabel( TRect( 1, 6, 11, 7), "Subject: ", b ));

	b1 = new TEditInput( TRect(2, 8, 42, 13), 1024); pd->insert( b1 );
	pd->insert( new TLabel( TRect( 1, 7, 35, 8), "Message: ", b1 ));

	b = new TInputLine( TRect( 11, 14, 42, 15), 128); pd->insert( b );
	pd->insert( new TLabel( TRect( 1, 14, 11, 15), "Button: ", b ));
	
	b = new TInputLine( TRect( 11, 16, 42, 17), 128); pd->insert( b );
	pd->insert( new TLabel( TRect( 1, 16, 11, 17), "URL: ", b ));

        pd->insert( new TButton( TRect( 27, 2, 42, 3 ), "~S~end msg", cmOK, bfDefault ));
        pd->insert( new TButton( TRect( 27, 4, 42, 5 ), "~C~ancel", cmCancel, bfNormal ));

	bcast_message.online_only = 1;
	strncpy(bcast_message.department, "", sizeof(bcast_message.department)-1);
	strncpy(bcast_message.subject, "", sizeof(bcast_message.subject));
	strncpy(bcast_message.message, "", sizeof(bcast_message.message));
	strncpy(bcast_message.button,  "", sizeof(bcast_message.button));
	strncpy(bcast_message.URL,  "", sizeof(bcast_message.URL));
	
	pd->setData( &bcast_message );
	b->focus();
	
	Control = deskTop->execView( pd );
	if (Control != cmCancel) 
	{
	   pd->getData( &bcast_message );
	   
	   ITrans.translateToClient(bcast_message.subject);
	   ITrans.translateToClient(bcast_message.message);
	   ITrans.translateToClient(bcast_message.button);
	   ITrans.translateToClient(bcast_message.URL);
	   
	   char newstr[1024]; unsigned short i, ind;

	   for (i=0, ind=0; i<strlen(bcast_message.message)+1; i++ )
	   {
	      if (bcast_message.message[i] == '\n')
	      {
	        newstr[ind] = 0x0D; ind++;
		if (ind > 1023) break;
		newstr[ind] = 0x0A; ind++;
		if (ind > 1023) break;
	      }
	      else
	      {
	        newstr[ind] = bcast_message.message[i]; ind++; 
		if (ind > 1023) break;
	      }
	   }
	   
	   newstr[1023] = 0;
	   strncpy(bcast_message.message, newstr, sizeof(bcast_message.message)-1);
	   
	   strncpy(bc_full_message, bcast_message.subject, sizeof(bc_full_message));
	   strncat(bc_full_message, CLUE_CHAR, 1);
           strncat(bc_full_message, bcast_message.message, 1024);
	   strncat(bc_full_message, CLUE_CHAR, 1);
	   strncat(bc_full_message, bcast_message.URL, 128);
	   strncat(bc_full_message, CLUE_CHAR, 1);
	   strncat(bc_full_message, bcast_message.button, 128);
           
	   unsigned short mess_len = strlen(bcast_message.subject) +
	                             strlen(bcast_message.message)+
				     strlen(bcast_message.button) +
				     strlen(bcast_message.URL) + 3;
	   
	   bc_full_message[mess_len+1] = 0;
	   
	   Packet bcast_pack;
	   bcast_pack.clearPacket(); bcast_pack.reset();
	   
	   /* prepare standart system header with password */
	   bcast_pack << (unsigned short)SYS_PROTO
                      << (unsigned short)ICQ_SYSxRCV_SYSBCAST_REQ
                      << (unsigned short)(strlen(lp_info_passwd())+1)
                      << lp_info_passwd();
		      
	   /* now time to put bcast message to packet */
	   bcast_pack << (unsigned short)bcast_message.online_only
		      << (unsigned  long)0x00  // BUGBUG - dep missing
		      << (unsigned short)0x14
		      << (unsigned short)(mess_len+1)
		      << bc_full_message;
	   
	   /* And send packet to server */
	   bcast_pack.from_ip   = server_addr;
           bcast_pack.from_port = lp_udp_port();
	   udp_send_direct_packet(bcast_pack); 
	   
	   sinfo.lbtime = time(NULL);
	}
    }
    destroy( pd );
}
