/**************************************************************************/
/*									  */
/* Copyright (c) 2000 by Alexandr V.Shutko, Khabarovsk, Russia		  */
/* All rights reserved.							  */
/*                                                                        */
/* Redistribution and use in source and binary forms, with or without	  */
/* modification, are permitted provided that the following conditions	  */
/* are met:								  */
/* 1. Redistributions of source code must retain the above copyright	  */
/*    notice, this list of conditions and the following disclaimer.	  */
/* 2. Redistributions in binary form must reproduce the above copyright	  */
/*    notice, this list of conditions and the following disclaimer in 	  */
/*    the documentation and/or other materials provided with the 	  */
/*    distribution.							  */
/*                                                                        */
/* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  */
/* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 	  */
/* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS  */
/* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 	  */
/* OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT   */
/* OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 	  */
/* BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,  */
/* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE   */
/* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 	  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.			  */
/*									  */
/**************************************************************************/


#include "icontrol.h"

/* Clock class constructor */
TClockView::TClockView( TRect& r ) : TView( r )
{
    strncpy(lastTime, "        ", 9);
    strncpy(curTime, "        ", 9);

	/* SS: now resizing under X works well */
	growMode = gfGrowLoX | gfGrowHiX;
}

/* Clock class painter */
void TClockView::draw()
{
    TDrawBuffer buf;
    char c = getColor(2);

    buf.moveChar(0, ' ', c, (short)size.x);
    buf.moveStr(0, curTime, c);
    writeLine(0, 0, (short)size.x, 1, buf);
}

/* Used to update clock view */
void TClockView::update()
{
    time_t t = time(0);
    char *date = ctime(&t);

    date[19] = '\0';
    strncpy(curTime, &date[11], 9);        /* Extract time. */

    if( strcmp(lastTime, curTime) )
        {
        drawView();
        strncpy(lastTime, curTime, 9);
        }
}

/* Constructor for status line */
TStatView::TStatView(TRect& r) : TView( r )
{
    strncpy(StatStr, "Server status: unknown...", sizeof(StatStr));
    
    /* SS: now resizing under X works well */
    growMode = gfGrowLoX | gfGrowLoY | gfGrowHiX | gfGrowHiY;
}

void TStatView::ch_status(char *new_stat) 
{
    strncpy(StatStr, new_stat, sizeof(StatStr));

    draw();
    /* SS: now resizing under X works well */
    growMode = gfGrowLoX | gfGrowLoY | gfGrowHiX | gfGrowHiY;
}

/* status class painter */
void TStatView::draw()
{
    TDrawBuffer buf;
    char c = getColor(2);

    buf.moveChar(0, ' ', c, (short)size.x);
    buf.moveStr(0, StatStr, c);
    writeLine(0, 0, (short)size.x, 1, buf);
}
