/**************************************************************************/
/*									  */
/* Copyright (c) 2000 by Alexandr V.Shutko, Khabarovsk, Russia		  */
/* All rights reserved.							  */
/*                                                                        */
/* Redistribution and use in source and binary forms, with or without	  */
/* modification, are permitted provided that the following conditions	  */
/* are met:								  */
/* 1. Redistributions of source code must retain the above copyright	  */
/*    notice, this list of conditions and the following disclaimer.	  */
/* 2. Redistributions in binary form must reproduce the above copyright	  */
/*    notice, this list of conditions and the following disclaimer in 	  */
/*    the documentation and/or other materials provided with the 	  */
/*    distribution.							  */
/*                                                                        */
/* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  */
/* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 	  */
/* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS  */
/* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 	  */
/* OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT   */
/* OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 	  */
/* BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,  */
/* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE   */
/* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 	  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.			  */
/*									  */
/**************************************************************************/

#include "icontrol.h"

/* IControl menu initialization */
TMenuBar *TMyApp::initMenuBar( TRect r )
{ 

    r.b.y = r.a.y + 1;    // set bottom line 1 line below top line
    return new TMenuBar( r,
        *new TSubMenu( "~C~ontrol", kbAltF )+
            *new TMenuItem( "~S~tart server", cm_serverstart, kbNoKey, hcNoContext, "" )+
            *new TMenuItem( "S~t~op server",  cm_serverstop, kbNoKey, hcNoContext, "" )+
	    *new TMenuItem( "~R~estart server",  cm_serverrestart, kbNoKey, hcNoContext, "" )+
            newLine()+
	    *new TMenuItem( "~E~dit config",  cm_EditConfig, 0, hcNoContext, "" )+
	    *new TMenuItem( "Re~l~oad config",  cm_cfgreload, 0, hcNoContext, "" )+
	    newLine()+
	    *new TMenuItem( "Server ~I~nfo",  cm_ShowInfo, 0, hcNoContext, "" )+
	    *new TMenuItem( "Sever ~p~rocesses",  cm_ShowPlist, 0, hcNoContext, "" )+
	    newLine()+
	    *new TMenuItem( "S~u~spend", cm_Suspend, 0, hcNoContext, "")+
            *new TMenuItem( "E~x~it", cmQuit, cmQuit, hcNoContext, "Alt-X" )+
	    
	*new TSubMenu( "~E~dit", kbAltE )+
	    *new TMenuItem( "Save", cmSave, 0, hcNoContext, "F2" )+
	    *new TMenuItem( "Save as...", cmSaveAs, 0, hcNoContext, "")+
	    *new TMenuItem( "Close", cm_None, 0, hcNoContext, "")+
	    newLine()+
	    *new TMenuItem( "Copy", cmCopy, 0, hcNoContext, "Ctrl-B")+
	    *new TMenuItem( "Cut", cmCut, 0, hcNoContext, "Ctrl-C")+
	    *new TMenuItem( "Paste", cmPaste, 0, hcNoContext, "Ctrl-V")+
	    
	
        *new TSubMenu( "~D~atabase", kbAltW )+
            *new TMenuItem( "~C~onnect", cm_None, 0, hcNoContext, "")+
	    *new TMenuItem( "~U~sers database", kbAltU,  (new TMenu(
               *new TMenuItem( "~U~sers info table", cm_None,   0, hcNoContext, "U",
                new TMenuItem( "~D~epartments table", cm_None,  0, hcNoContext, "D",
                new TMenuItem( "~A~dmin list table", cm_None,   0, hcNoContext, "A", 
                new TMenuItem( "~M~essages table", cm_None,     0, hcNoContext, "M",
	        new TMenuItem( "~O~nline users table", cm_None, 0, hcNoContext, "O",
	        new TMenuItem( "Online ~c~ontacts table", cm_None, 0, hcNoContext,"C")))))))))+
	    newLine()+
	    *new TMenuItem( "Check & ~f~ix database", cm_Prepare,  0, hcNoContext, "" )+
	    *new TMenuItem( "Purge & ~R~ecreate", cm_Purge,  0, hcNoContext, "" )+
	    newLine()+
	    *new TMenuItem( "Connect ~o~ptions", cm_dblogin,  0, hcNoContext, "" )+

        *new TSubMenu( "~A~dministration", kbAltW )+
            *new TMenuItem( "~E~dit notes...", cm_None,  0, hcNoContext, "" )+
	    *new TMenuItem( "Edit ~p~ostnotes...", cm_None,    0, hcNoContext, "" )+
	    newLine()+
	    *new TMenuItem( "Re~q~uest table", cm_None,  0, hcNoContext, "" )+
	    *new TMenuItem( "~B~roadcast message", cm_Broadcast, 0, hcNoContext, "" )+

	*new TSubMenu( "~W~indows", 0) +
    	    *new TMenuItem( "~R~esize/move", cmResize, kbCtrlF5, hcNoContext, "Ctrl-F5" ) +
    	    *new TMenuItem( "~Z~oom", cmZoom, kbF5, hcNoContext, "F5" ) +
    	    *new TMenuItem( "~N~ext", cmNext, kbF6, hcNoContext, "F6" ) +
    	    *new TMenuItem( "~C~lose", cmClose, kbAltF3, hcNoContext, "Alt-F3" ) +
    	    *new TMenuItem( "~T~ile", cmTile, kbNoKey, hcNoContext ) +
    	    *new TMenuItem( "C~a~scade", cmCascade, kbNoKey, hcNoContext )+
	    *new TMenuItem( "~S~how Terminal", cm_ShowTerm, kbNoKey, hcNoContext)+
	
        *new TSubMenu( "~H~elp", kbAltH )+
            *new TMenuItem( "~A~bout...", cm_ShowAbout,  0, hcNoContext, "" )+
	    *new TMenuItem( "~H~elp...", cm_None,    0, hcNoContext, "" )+
	    newLine()+
	    *new TMenuItem( "Thanks", cm_None,  0, hcNoContext, "" )+
	    newLine()+
	    *new TMenuItem( "Bug report", cm_None,  0, hcNoContext, "" )
        );
}
