/**************************************************************************/
/*									  */
/* Copyright (c) 2000 by Alexandr V.Shutko, Khabarovsk, Russia		  */
/* All rights reserved.							  */
/*									  */
/* Redistribution and use in source and binary forms, with or without	  */
/* modification, are permitted provided that the following conditions	  */
/* are met:								  */
/* 1. Redistributions of source code must retain the above copyright	  */
/*    notice, this list of conditions and the following disclaimer.	  */
/* 2. Redistributions in binary form must reproduce the above copyright	  */
/*    notice, this list of conditions and the following disclaimer in 	  */
/*    the documentation and/or other materials provided with the 	  */
/*    distribution.							  */
/*									  */
/* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  */
/* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 	  */
/* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS  */
/* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 	  */
/* OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT   */
/* OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 	  */
/* BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,  */
/* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE   */
/* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 	  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.			  */
/*									  */
/**************************************************************************/

extern int incoming_pipe_fd;		  /* incoming pipe descriptor */
extern int outgoing_pipe_fd;		  /* outgoing pipe descriptor */
extern int event_pipe_fd;		  /* event pipe descriptor    */

extern int wwpsockfd;			  /* web-pager socket handler */
extern struct pollfd sock_fds[2];	  /* array for handlers       */
extern struct pollfd evnt_fds[2];	  /* array for handlers       */

extern struct sockaddr_un wp_serv_addr;
extern socklen_t wp_saddrlen;

extern struct sockaddr_un ip_serv_addr;
extern struct sockaddr_un ip_clnt_addr;
extern socklen_t ip_saddrlen;

extern struct sockaddr_un op_serv_addr;
extern struct sockaddr_un op_clnt_addr;
extern socklen_t op_saddrlen;

extern struct sockaddr_un ep_serv_addr;
extern struct sockaddr_un ep_clnt_addr;
extern socklen_t ep_saddrlen;

extern int SEM_KEY;			// key to create IPC objects
extern int semaphore_id;		// semaphores identificator
extern int messqueue_id;		// ipc messages identificator
extern int sharedmem_id;		// shared memory identificator

extern int process_role;		// ROLE_PACKET, ROLE_SOCKET, ROLE_EVENT
extern int childs_check;		// is any child death?
extern int * pack_buf[MAX_PACKET_SIZE]; // buffer for packets

extern struct in_addr bind_interface;	// udp listen interface
extern struct in_addr old_interface;
extern int old_sock_port;
extern int msockfd;			// main network socket

extern PGconn   *users_dbconn;

extern int DEBUGLEVEL;
extern int LOGLEVEL;

extern class ITranslator ITrans;
extern FILE *pidFP;

extern int sems_ready;
extern int exit_ok;

extern BOOL no_deth_messages;

extern time_t server_started;
extern time_t config_loaded;

extern class Packet int_pack;
extern class Packet reply_pack;
extern class Packet pipe_pack;

extern unsigned long pack_processed;

extern struct ipc_structure *ipc_vars;  // pointer to structure in shared mem

extern struct child_record *cl_begin;
extern struct child_record *cl_last;
extern struct child_record *cl_list;

extern char temp_buffer[MAX_PACKET_SIZE+1024];
