/**************************************************************************/
/*									  */
/* Copyright (c) 2000 by Alexandr V.Shutko, Khabarovsk, Russia		  */
/* All rights reserved.							  */
/*									  */
/* Redistribution and use in source and binary forms, with or without	  */
/* modification, are permitted provided that the following conditions	  */
/* are met:								  */
/* 1. Redistributions of source code must retain the above copyright	  */
/*    notice, this list of conditions and the following disclaimer.	  */
/* 2. Redistributions in binary form must reproduce the above copyright	  */
/*    notice, this list of conditions and the following disclaimer in 	  */
/*    the documentation and/or other materials provided with the 	  */
/*    distribution.							  */
/*									  */
/* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  */
/* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 	  */
/* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS  */
/* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 	  */
/* OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT   */
/* OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 	  */
/* BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,  */
/* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE   */
/* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 	  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.			  */
/*									  */
/**************************************************************************/

#include "includes.h"

int SEM_KEY;			 // key to create IPC objects
int semaphore_id;		 // semaphores identificator
int messqueue_id;		 // ipc messages identificator
int sharedmem_id;		 // shared memory identificator

int msockfd;			 // main socket handler
int incoming_pipe_fd;		 // incoming pipe handler
int outgoing_pipe_fd;		 // outgoing pipe handler
int event_pipe_fd;		 // event pipe handler
int wwpsockfd;			 // web-pager socket handler

struct pollfd sock_fds[2];	 // array for handlers
struct pollfd evnt_fds[2];	 // array for handlers

struct sockaddr_un ip_serv_addr;
struct sockaddr_un ip_clnt_addr;
socklen_t ip_saddrlen;

struct sockaddr_un op_serv_addr;
struct sockaddr_un op_clnt_addr;
socklen_t op_saddrlen;

struct sockaddr_un ep_serv_addr;
struct sockaddr_un ep_clnt_addr;
socklen_t ep_saddrlen;

struct sockaddr_un wp_serv_addr;
socklen_t wp_saddrlen;

int process_role;		 // ROLE_PACKET, ROLE_SOCKET, ROLE_EVENT
int childs_check;		 // is any child death? 

struct child_record *cl_begin = NULL;
struct child_record *cl_last  = NULL;
struct child_record *cl_list  = NULL;

struct in_addr bind_interface;	 // main interface value
struct in_addr old_interface;	 // old interface value

int old_sock_port;
int sems_ready		= 0;
int exit_ok		= 1;	 // set it to 1 to forbid exit on SIGINT

BOOL no_deth_messages   = False;

time_t server_started;		 // time when server was started
time_t config_loaded;		 // last time when config was loaded

unsigned long pack_processed;    // total packets processed

struct ipc_structure *ipc_vars;  // structure located in shared memory

FILE *pidFP = NULL;		 // system pidfile handler

int     DEBUGLEVEL 	= 1;
int     LOGLEVEL 	= 1;

PGconn   *users_dbconn  = NULL;  // database connection structure
ITranslator ITrans;		 // string translator

class Packet int_pack;
class Packet reply_pack;
class Packet pipe_pack;

int * pack_buf[MAX_PACKET_SIZE]; // buffer for packets
char  temp_buffer[MAX_PACKET_SIZE+1024];
