/**************************************************************************/
/*									  */
/* Copyright (c) 2000 by Alexandr V.Shutko, Khabarovsk, Russia		  */
/* All rights reserved.							  */
/*									  */
/* Redistribution and use in source and binary forms, with or without	  */
/* modification, are permitted provided that the following conditions	  */
/* are met:								  */
/* 1. Redistributions of source code must retain the above copyright	  */
/*    notice, this list of conditions and the following disclaimer.	  */
/* 2. Redistributions in binary form must reproduce the above copyright	  */
/*    notice, this list of conditions and the following disclaimer in 	  */
/*    the documentation and/or other materials provided with the 	  */
/*    distribution.							  */
/*									  */
/* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  */
/* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 	  */
/* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS  */
/* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 	  */
/* OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT   */
/* OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 	  */
/* BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,  */
/* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE   */
/* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 	  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.			  */
/*									  */
/**************************************************************************/

#ifndef _V5_PROTO_H
#define _V5_PROTO_H

void handle_v5_proto(Packet &pack);
void V5Encrypt(Packet &pack);
void V5Decrypt(Packet &pack);
unsigned long ReverseLong(unsigned long l);
unsigned long GetKey(Packet &pack);
unsigned long calculate_checkcode(Packet &pack);
void PutKey(Packet &pack, unsigned long cc);
void v5_send_indirect(Packet &pack, unsigned long to_uin, unsigned short seq1);
void v5_proto_init();
void v5_send_busy(Packet &pack);
void v5_send_ack(Packet &pack);
void v5_send_login_err(Packet &pack, char *errmessage);
void v5_send_test_err(Packet &pack, unsigned short commd, char *errmessage);
void v5_send_pass_err(Packet &pack);
void v5_send_login_reply(Packet &pack, struct login_user_info &userinfo);
void v5_send_not_connected(Packet &pack);
void v5_send_end_contact(struct online_user &user);
void v5_send_user_online(struct online_user &to_user, struct online_user &user);
void v5_send_user_offline(struct online_user &to_user, unsigned long uin);
void v5_send_user_status(struct online_user &to_user, struct online_user &user);

void v5_process_login();
void v5_process_contact();
void v5_process_ack();
void v5_process_logoff();
void v5_process_ping();
void v5_process_lmeta();
void v5_process_status();

#endif /* _V5_PROTO_H */
