/*
 * editstat.cc
 *
 * Turbo Vision - Version 2.0
 *
 * Copyright (c) 1994 by Borland International
 * All Rights Reserved.
 *
 * Modified by Sergio Sigala <ssigala@globalnet.it>
 * Modified by Shutko Alexandr <AVShutko@mail.khstu.ru>
 */

#define Uses_MsgBox
#define Uses_TSItem
#define Uses_TCheckBoxes
#define Uses_TView
#define Uses_TProgram
#define Uses_TDialog
#define Uses_TFileDialog
#define Uses_TLabel
#define Uses_TInputLine
#define Uses_TButton
#define Uses_TRect
#define Uses_TEditor
#define Uses_TEditorDialog
#define Uses_TFindDialogRec
#define Uses_TReplaceDialogRec
#include <tvision/tv.h>

ushort defEditorDialog( int dialog, ... )
{
  ushort  dlg_result;
  int Control;
  
  typedef struct Trstr
  {
    char find[50];
    char replace[50];
    ushort global;
    ushort sense;
    ushort prompt;
    ushort whole;

  } Trstr;

  typedef struct Tsstr
  {
    char find[50];
    ushort sense;
    ushort whole;

  } Tsstr;
  
  struct Trstr rtstr;
  struct Tsstr ststr;
  class  TRect scr_size;
  class  TView *b, *b1;
  struct TFindDialogRec *Rec_find;
  struct TReplaceDialogRec *Rec_replace;
  class  TPoint *point, *dpoint;
  class  TDialog *pd;
  class  TFileDialog *tfd;
  char   tstr[50];
  char   temp_msg[128];
  va_list ap;

  va_start(ap, dialog);
  
  switch (dialog)
  {
     case  edOutOfMemory:
           messageBox( "Program out of memory.\nOperation can't be finished.",
           mfWarning | mfOKButton);
           break;
     case  edReadError:
           messageBox( "Error handled. \nCan't read data from file.",
           mfWarning | mfOKButton);     
           break;
     case  edWriteError:
           messageBox( "Error handled. \nCan't write data to file.",
           mfWarning | mfOKButton);     
           break;
     case  edCreateError:
           messageBox( "Error handled. \nCan't create file.",
           mfWarning | mfOKButton);
           break;
     case  edSaveModify:
           dlg_result = messageBox( "File changed but not saved. \nDo you want to save it?",
           mfWarning | mfYesButton | mfNoButton | mfCancelButton);

 	   switch (dlg_result)
	   {
	     case cmYes: va_end(ap); return cmYes;
	     case cmNo:  va_end(ap); return cmNo;
	     case cmCancel: va_end(ap); return cmCancel;
	     default: va_end(ap); return cmCancel;
	   };
	   
     case  edSaveUntitled:
           break;
     case  edSaveAs:
           tfd = new TFileDialog("*", "Save As...", "Filename: ", fdOKButton, 0);
	   Control = TProgram::application->execView( tfd );
           break;
     case  edFind:
           pd = new TDialog( TRect( 20, 10, 68, 15), "<Find>" );
	   b = new TInputLine( TRect( 8, 1, 32, 2), 50); pd->insert( b );
	   pd->insert( new TLabel(  TRect( 1, 1, 7, 2), "Text: ", b ));

	   pd->insert( new TCheckBoxes( TRect( 2, 3, 22, 4), 
        	       new TSItem( "~C~ase sensitive", 0 )));
	   pd->insert( new TCheckBoxes( TRect( 23, 3, 46, 4), 
        	       new TSItem( "~W~hole words only", 0 )));

	   pd->insert( new TButton( TRect( 33, 1, 46, 2), "~S~earch", cmOK, bfDefault));
	   Rec_find = va_arg(ap, TFindDialogRec *);
	   
	   if ((Rec_find->options & efWholeWordsOnly) != 0 ) { ststr.whole = 1; }
	   else { ststr.whole = 0; }	   
	   if ((Rec_find->options & efCaseSensitive) != 0 ) { ststr.sense = 1; }
	   else { ststr.sense = 0; }
	   strncpy(ststr.find, (char *)Rec_find->find, 49);
	   pd->setData(&ststr);
	   
	   b->focus();
	   Control = TProgram::application->execView( pd );
	   if (Control == cmCancel) break;
	   pd->getData(&ststr);

	   if ((ststr.whole & 1) != 0 )  Rec_find->options |= efWholeWordsOnly;
	   if ((ststr.sense & 1) != 0 )  Rec_find->options |= efCaseSensitive;
	   
	   strncpy((char *)Rec_find->find, ststr.find, 49);
	   va_end(ap);
	   return cmOK;
           break;
     case  edSearchFailed:
           messageBox( "Search string not found.",
           mfWarning | mfOKButton);
           break;
     case  edReplace:

           pd = new TDialog( TRect( 20, 10, 68, 18), "<Replace>" );
	  
	   b = new TInputLine( TRect( 11, 1, 32, 2), 50); pd->insert( b );
	   pd->insert( new TLabel(  TRect( 1, 1, 9, 2), "Search: ", b ));
	   b1 = new TInputLine( TRect( 11, 3, 32, 4), 50); pd->insert( b1 );
	   pd->insert( new TLabel(  TRect( 1, 3, 10, 4), "Replace: ", b1 ));

	   pd->insert( new TCheckBoxes( TRect( 2, 5, 22, 6), 
        	       new TSItem( "Replace ~a~ll", 0 )));
	   pd->insert( new TCheckBoxes( TRect( 2, 6, 22, 7), 
        	       new TSItem( "Case sens~i~tive", 0 )));
	   pd->insert( new TCheckBoxes( TRect( 23, 5, 46, 6), 
        	       new TSItem( "~P~rompt on replace", 0 )));
	   pd->insert( new TCheckBoxes( TRect( 23, 6, 46, 7), 
        	       new TSItem( "~W~hole words only", 0 )));

	   pd->insert( new TButton( TRect( 33, 1, 46, 2), "~O~k", cmOK, bfDefault));
	   pd->insert( new TButton( TRect( 33, 3, 46, 4), "~C~ancel", cmCancel, bfNormal));

    	   b->focus();
	   Rec_replace = va_arg(ap, TReplaceDialogRec *);

	   if ((Rec_replace->options & efReplaceAll) != 0 ) { rtstr.global = 1;}
	   else { rtstr.global = 0; }
	   if ((Rec_replace->options & efPromptOnReplace) != 0 ) { rtstr.prompt = 1; }
	   else { rtstr.prompt = 0; }	   
	   if ((Rec_replace->options & efWholeWordsOnly) != 0 ) { rtstr.whole = 1; }
	   else { rtstr.whole = 0; }	   
	   if ((Rec_replace->options & efCaseSensitive) != 0 ) { rtstr.sense = 1; }
	   else { rtstr.sense = 0; }	   
	   strncpy(rtstr.find,    (char *)Rec_replace->find, 49);
	   strncpy(rtstr.replace, (char *)Rec_replace->replace, 49);
	   
	   pd->setData(&rtstr);
	   
	   Control = TProgram::application->execView( pd );
	   if (Control == cmCancel) break;
	   pd->getData(&rtstr);
	   Rec_replace->options = efDoReplace;

	   if ((rtstr.global & 1) != 0 ) Rec_replace->options |= efReplaceAll;
	   if ((rtstr.prompt & 1) != 0 ) Rec_replace->options |= efPromptOnReplace;
	   if ((rtstr.whole & 1) != 0 )  Rec_replace->options |= efWholeWordsOnly;
	   if ((rtstr.sense & 1) != 0 )  Rec_replace->options |= efCaseSensitive;
	   strncpy((char *)Rec_replace->find,    rtstr.find, 49);
	   strncpy((char *)Rec_replace->replace, rtstr.replace, 49);

	   va_end(ap);
	   return cmOK;
           break;
     case  edReplacePrompt:
           point = va_arg(ap, TPoint *);
	   dpoint = new TPoint;
	   scr_size = TProgram::application->getExtent();

	   if ( (point->y - scr_size.a.y) < 8) { dpoint->y = point->y+2; }
	   else 
	   {
	      if ( (scr_size.b.y - point->y) < 8) { dpoint->y = point->y-5; }
	      else
	      {
	         dpoint->y = point->y-5;
	      }
	   }
	   
	   dpoint->x = 10;
           snprintf(temp_msg, 127, "Replace with: %s", va_arg(ap, char *));
	   pd = new TDialog( TRect( dpoint->x, dpoint->y, dpoint->x+51, dpoint->y+4), 
	                     "Replace confirm" );
	   pd->insert( new TLabel(  TRect(  1, 1, 50, 2), temp_msg, NULL));
	   pd->insert( new TButton( TRect( 17, 2, 32, 3), "~N~o", cmNo, bfNormal));
	   pd->insert( new TButton( TRect( 34, 2, 49, 3), "~C~ancel", cmCancel, bfNormal));
	   pd->insert( new TButton( TRect(  1, 2, 15, 3), "~Y~es", cmYes, bfDefault));
	   Control = TProgram::application->execView( pd );
           return Control;

     default: break;
  }

  return cmCancel;
    
}

TEditorDialog TEditor::editorDialog = defEditorDialog;
ushort TEditor::editorFlags = efBackupFiles | efPromptOnReplace;
char TEditor::findStr[maxFindStrLen] = "";
char TEditor::replaceStr[maxReplaceStrLen] = "";
TEditor * TEditor::clipboard = 0;
